#!/bin/sh

verbose=false

if [ "x$1" = "x-v" ]
then
	verbose=true
	out=/dev/stdout
	err=/dev/stderr
else
	out=/dev/null
	err=/dev/null
fi

pts=5
timeout=30

runbochs() {
	# Find the address of the kernel readline function,
	# which the kernel monitor uses to read commands interactively.
	brkaddr=`grep readline obj/kern/kernel.sym | sed -e's/ .*$//g'`
	#echo "brkaddr $brkaddr"

	# Run Bochs, setting a breakpoint at readline(),
	# and feeding in appropriate commands to run, then quit.
	(
		echo vbreak 0x8:0x$brkaddr
		echo c
		echo die
		echo quit
	) | (
		ulimit -t $timeout
		bochs -q 'display_library: nogui' \
			'parport1: enabled=1, file="bochs.out"' \
			>$out 2>$err
	)
}



gmake
runbochs

score=0

	# echo -n "Printf: "
	awk 'BEGIN{printf("Printf: ");}' </dev/null
	if grep "6828 decimal is 15254 octal!" bochs.out >/dev/null
	then
		score=`echo 20+$score | bc`
		echo OK
	else
		echo WRONG
	fi

	# echo -n "Printf: "
	awk 'BEGIN{printf("Backtrace: ");}' </dev/null
	cnt=`grep "ebp f0109...  eip f0100...  args" bochs.out|wc -w`
	if [ $cnt -eq 80 ]
	then
		score=`echo 15+$score | bc`
		awk 'BEGIN{printf("Count OK");}' </dev/null
	else
		awk 'BEGIN{printf("Count WRONG");}' </dev/null
	fi

	cnt=`grep "ebp f0109...  eip f0100...  args" bochs.out | awk 'BEGIN { FS = ORS = " " }
{ print $6 }
END { printf("\n") }' | grep '^00000000 00000000 00000001 00000002 00000003 00000004 00000005' | wc -w`
	if [ $cnt -eq 8 ]; then
		score=`echo 15+$score | bc`
		echo , Args OK
	else
		echo , Args WRONG
	fi

echo "Score: $score/50"


